/*
 * valve.cpp
 *
 *  Created on: 11 янв. 2020 г.
 *      Author: Vladimir Sadovnikov <lsp.plugin@gmail.com>
 *
 * This file is part of tamgamp.lv2 <https://github.com/sadko4u/tamgamp.lv2>.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include <resources/valve.h>

namespace tamgamp_lv2
{
    /*
     * data tables generated by guitarix tools: tools/tube_transfer.py
     */
    #include <generated/valve/12ax7.h>
    #include <generated/valve/12AU7.h>
    #include <generated/valve/12AT7.h>
    #include <generated/valve/6V6.h>
    #include <generated/valve/6DJ8.h>
    #include <generated/valve/6C16.h>
    #include <generated/valve/6L6CG.h>
    #include <generated/valve/EL34.h>
    #include <generated/valve/12AY7.h>
    #include <generated/valve/JJECC83S.h>
    #include <generated/valve/JJECC99.h>
    #include <generated/valve/EL84.h>
    #include <generated/valve/EF86.h>
    #include <generated/valve/SVEL34.h>

    table1d *tubetab[TUBE_TABLE_SIZE] = {
        &static_cast<table1d&>(tubetable_12AX7[0]),
        &static_cast<table1d&>(tubetable_12AX7[1]),
        &static_cast<table1d&>(tubetable_6V6[0]),
        &static_cast<table1d&>(tubetable_6V6[1]),
        &static_cast<table1d&>(tubetable_12AU7[0]),
        &static_cast<table1d&>(tubetable_12AU7[1]),
        &static_cast<table1d&>(tubetable_6DJ8[0]),
        &static_cast<table1d&>(tubetable_6DJ8[1]),
        &static_cast<table1d&>(tubetable_12AT7[0]),
        &static_cast<table1d&>(tubetable_12AT7[1]),
        &static_cast<table1d&>(tubetable_6C16[0]),
        &static_cast<table1d&>(tubetable_6C16[1]),
        &static_cast<table1d&>(tubetable_6L6CG[0]),
        &static_cast<table1d&>(tubetable_6L6CG[1]),
        &static_cast<table1d&>(tubetable_EL34[0]),
        &static_cast<table1d&>(tubetable_EL34[1]),
        &static_cast<table1d&>(tubetable_12AY7[0]),
        &static_cast<table1d&>(tubetable_12AY7[1]),
        &static_cast<table1d&>(tubetable_JJECC83S[0]),
        &static_cast<table1d&>(tubetable_JJECC83S[1]),
        &static_cast<table1d&>(tubetable_JJECC99[0]),
        &static_cast<table1d&>(tubetable_JJECC99[1]),
        &static_cast<table1d&>(tubetable_EL84[0]),
        &static_cast<table1d&>(tubetable_EL84[1]),
        &static_cast<table1d&>(tubetable_EF86[0]),
        &static_cast<table1d&>(tubetable_EF86[1]),
        &static_cast<table1d&>(tubetable_SVEL34[0]),
        &static_cast<table1d&>(tubetable_SVEL34[1]),
    };
}

